// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/16AICS32/samples/regs/main.h $
// $Rev: 50492 $
// $Date: 2022-02-22 18:01:53 -0600 (Tue, 22 Feb 2022) $

// 16AICS32: Sample Application: header file

#ifndef	__MAIN_H__
#define	__MAIN_H__

#include <ctype.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>

#include "16aics32_main.h"



// macros *********************************************************************

#define	SIZEOF_ARRAY(a)				(sizeof((a)) / sizeof((a)[0]))



// data types *****************************************************************

typedef struct
{
	const char*	name;				// NULL terminates list.
	const char*	desc;				// optional
	void		(*func)(int fd);	// NULL terminates list.
} menu_item_t;

typedef struct
{
	const char*			title;
	const menu_item_t*	list;
} menu_t;



// prototypes *****************************************************************

void	menu_call(int fd, const menu_t* menu);
int		menu_select(const menu_t* menu);

int		perform_tests(int fd);

void	reg_mod_by_name(int fd);
void	reg_mod_by_offset(int fd);



#endif
